function goto_random_level(previous_room){
	var lvl_num = irandom(ds_list_size(global.task_map)-1)
	var room_name = global.task_map[| lvl_num][$ "level_room"]
	if !is_undefined(previous_room){
		while(room_name == previous_room){
			lvl_num = irandom(ds_list_size(global.task_map)-1)
			room_name = global.task_map[| lvl_num][$ "level_room"]
		}
	}
	room_goto(room_name)
	return global.task_map[| lvl_num]
}


function create_banner(){
	var _banner_obj = instance_create_layer(-736,304,"Instances",obj_level_banner)
	var _seqElm = layer_sequence_create("Instances", 0, 0, seq_banner)
	var _seqInst = layer_sequence_get_instance(_seqElm)
	sequence_instance_override_object(_seqInst,obj_level_banner,_banner_obj)
	layer_sequence_speedscale(_seqElm,1*SPD_MULTIPLIER*DELTAMULT)
	return _banner_obj
}

function change_level_state(state){
	if instance_exists(obj_level_banner) exit
	global.pause = true
	obj_controller.level_state = state
	
	switch(state){
		case lvl_state.completed:
			obj_controller.pause_time = true
			global.completed_levels++
			var _banner_obj = create_banner()
			_banner_obj.image_index = 1
		break
		case lvl_state.failed: 
			obj_controller.pause_time = true
			obj_controller.current_streak = 0
			global.failed_levels++
			if obj_controller.current_streak > global.record_streak{global.record_streak = obj_controller.current_streak}
			var _banner_obj = create_banner()
			_banner_obj.image_index = 0
		break
		case lvl_state.game_over:
			obj_controller.pause_time = true
			var _banner_obj = create_banner()
			_banner_obj.image_index = 2
		break
	}
	with(obj_player){
		allow_control = false
	}
}

	
function update_game_state(previous_room){
	if !is_undefined(previous_room){
		var accessor = goto_random_level(previous_room)
	}else{
		var accessor = goto_random_level()	
	}

	if !instance_exists(obj_controller) instance_create_depth(0,0,1,obj_controller)
	with obj_controller{
		current_task = accessor
	}
}

function kill_player(){
	with(instance_create_depth(obj_player.x,obj_player.y,0,obj_player_died)){
	hsp = obj_player.hsp
	vsp = obj_player.vsp
	}
	with(obj_player){instance_destroy()}
}